<template>
    <div class="relative">
        <div
            v-if="loading"
            class="absolute w-full h-full bg-white z-20"
        >
            <div class="absolute top-1/2 left-1/2 transform -translate-x-1/2 -translate-y-1/2">
                <svg class="w-8 h-8 mr-2 text-gray-200 animate-spin dark:text-gray-600 fill-blue-600" viewBox="0 0 100 101" fill="none" xmlns="http://www.w3.org/2000/svg">
                    <path d="M100 50.5908C100 78.2051 77.6142 100.591 50 100.591C22.3858 100.591 0 78.2051 0 50.5908C0 22.9766 22.3858 0.59082 50 0.59082C77.6142 0.59082 100 22.9766 100 50.5908ZM9.08144 50.5908C9.08144 73.1895 27.4013 91.5094 50 91.5094C72.5987 91.5094 90.9186 73.1895 90.9186 50.5908C90.9186 27.9921 72.5987 9.67226 50 9.67226C27.4013 9.67226 9.08144 27.9921 9.08144 50.5908Z" fill="currentColor"/>
                    <path d="M93.9676 39.0409C96.393 38.4038 97.8624 35.9116 97.0079 33.5539C95.2932 28.8227 92.871 24.3692 89.8167 20.348C85.8452 15.1192 80.8826 10.7238 75.2124 7.41289C69.5422 4.10194 63.2754 1.94025 56.7698 1.05124C51.7666 0.367541 46.6976 0.446843 41.7345 1.27873C39.2613 1.69328 37.813 4.19778 38.4501 6.62326C39.0873 9.04874 41.5694 10.4717 44.0505 10.1071C47.8511 9.54855 51.7191 9.52689 55.5402 10.0491C60.8642 10.7766 65.9928 12.5457 70.6331 15.2552C75.2735 17.9648 79.3347 21.5619 82.5849 25.841C84.9175 28.9121 86.7997 32.2913 88.1811 35.8758C89.083 38.2158 91.5421 39.6781 93.9676 39.0409Z" fill="currentFill"/>
                </svg>
            </div>
        </div>
        <div
            v-if="Array.isArray(filters) && filters.length"
            class="intro-y w-full pb-6 mb-6 border-b-2 border-b-gray-400"
        >
            <div
                v-for="(row, i) in filters"
                :key="`filter-${i}`"
                class="flex space-x-2 w-full mb-2"
            >
                <template
                    v-if="Array.isArray(row) && row.length"
                >
                    <div
                        v-for="(row2, i2) in row"
                        :key="`filter-inner-${i}-${i2}`"
                        class="flex-auto"
                    >
                        <label class="block text-sm font-medium">{{ row2.label }}</label>
                        <div
                            class="mt-1 relative rounded-md shadow-sm"
                        >
                            <div
                                v-if="row2.type === 'select'"
                                class="relative"
                            >
                                <select
                                    :name="row2.name"
                                    class="form-control"
                                >
                                    <option
                                        value=""
                                        :selected="filter_form[row2.name] === ''"
                                    >
                                        {{ row2.placeholder || $t('all') }}
                                    </option>
                                    <option
                                        v-for="(opt, oi) in row2.options"
                                        :key="`filter-${i}-${i2}-${oi}`"
                                        :value="opt.value"
                                        :selected="filter_form[row2.name] === opt.value"
                                    >
                                        {{ opt.text }}
                                    </option>
                                </select>
                                <div class="pointer-events-none absolute inset-y-0 right-0 flex items-center px-2 fill-black">
                                    <svg class="fill-current h-4 w-4" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20"><path d="M9.293 12.95l.707.707L15.657 8l-1.414-1.414L10 10.828 5.757 6.586 4.343 8z"/></svg>
                                </div>
                            </div>
                            <input
                                v-else
                                v-model="filter_form[row2.name]"
                                :type="row2.type"
                                :name="row2.name"
                                class="form-control"
                                :placeholder="row2.placeholder || $t('all')"
                            >
                        </div>
                    </div>
                </template>
                <template
                    v-else
                >
                    <div class="flex-1">
                        <label class="block text-sm font-medium">{{ row.label }}</label>
                        <div
                            class="mt-1 relative rounded-md shadow-sm"
                        >
                            <div
                                v-if="row.type === 'select'"
                                class="relative"
                            >
                                <select
                                    v-model="filter_form[row.name]"
                                    :name="row.name"
                                    class="form-control"
                                >
                                    <option
                                        value=""
                                        :selected="filter_form[row.name] === ''"
                                    >
                                        {{ row.placeholder || $t('all') }}
                                    </option>
                                    <option
                                        v-for="(opt, oi) in row.options"
                                        :key="`filter-${i}-${oi}`"
                                        :value="opt.value"
                                        :selected="filter_form[row.name] === opt.value"
                                    >
                                        {{ opt.text }}
                                    </option>
                                </select>
                                <div class="pointer-events-none absolute inset-y-0 right-0 flex items-center px-2">
                                    <svg class="fill-current h-4 w-4" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20"><path d="M9.293 12.95l.707.707L15.657 8l-1.414-1.414L10 10.828 5.757 6.586 4.343 8z"/></svg>
                                </div>
                            </div>
                            <input
                                v-else
                                v-model="filter_form[row.name]"
                                :type="row.type"
                                :name="row.name"
                                class="form-control"
                                :placeholder="row.placeholder || $t('all')"
                            >
                        </div>
                    </div>
                </template>
            </div>
            <div class="flex w-full space-x-2 grid grid-cols-2">
                <div class="col-span-1">
                    <auto-button
                        :disabled="loading"
                        @click="onFilterSubmit"
                    >
                        <div
                            class="flex justify-center space-x-2 items-center"
                        >
                            <svg
                                class="w-4 h-4 fill-white"
                                xmlns="http://www.w3.org/2000/svg"
                                x="0px"
                                y="0px"
                                viewBox="0 0 121.702 122.881"
                                xml:space="preserve"
                            >
                                <g><path d="M53.617,0c14.806,0,28.21,6.001,37.913,15.705c9.703,9.703,15.704,23.107,15.704,37.913 c0,10.832-3.213,20.914-8.737,29.346l23.205,25.291l-16.001,14.627L83.322,98.258c-8.503,5.67-18.718,8.977-29.705,8.977 c-14.806,0-28.21-6.002-37.913-15.705C6.001,81.826,0,68.422,0,53.617c0-14.806,6.001-28.21,15.704-37.913 C25.407,6.001,38.812,0,53.617,0L53.617,0z M87.3,19.934c-8.619-8.62-20.528-13.951-33.683-13.951s-25.063,5.332-33.683,13.951 c-8.62,8.62-13.952,20.529-13.952,33.683s5.332,25.063,13.952,33.682c8.62,8.621,20.528,13.951,33.683,13.951 S78.681,95.92,87.3,87.299c8.62-8.619,13.951-20.527,13.951-33.682S95.92,28.554,87.3,19.934L87.3,19.934z"/></g>
                            </svg>
                            <span>
                                {{ $t('search') }}
                            </span>
                        </div>
                    </auto-button>
                </div>
                <div class="col-span-1">
                    <auto-button
                        type="danger"
                        :disabled="!filtered"
                        @click="onFilterReset"
                    >
                        <div
                            class="flex justify-center space-x-2 items-center"
                        >
                            <svg
                                class="w-4 h-4 fill-white"
                                x="0px"
                                y="0px"
                                viewBox="0 0 122.878 122.88"
                                xml:space="preserve"

                            >
                                <g><path d="M1.426,8.313c-1.901-1.901-1.901-4.984,0-6.886c1.901-1.902,4.984-1.902,6.886,0l53.127,53.127l53.127-53.127 c1.901-1.902,4.984-1.902,6.887,0c1.901,1.901,1.901,4.985,0,6.886L68.324,61.439l53.128,53.128c1.901,1.901,1.901,4.984,0,6.886 c-1.902,1.902-4.985,1.902-6.887,0L61.438,68.326L8.312,121.453c-1.901,1.902-4.984,1.902-6.886,0 c-1.901-1.901-1.901-4.984,0-6.886l53.127-53.128L1.426,8.313L1.426,8.313z"/></g>
                            </svg>
                            <span>
                                {{ $t('reset') }}
                            </span>
                        </div>
                    </auto-button>
                </div>
            </div>
        </div>
        <div
            v-if="hasAction"
            class="intro-x w-full mb-2 h-auto flex justify-start"
        >
            <slot name="action" />
        </div>
        <div
            class="intro-y flex justify-start space-x-2 items-center"
        >
            <auto-button
                v-if="hasExport"
                type="primary"
                :outline="true"
                :block="false"
                @click="onExport"
            >
                <div
                    class="flex justify-center space-x-2 items-center"
                >
                    <svg
                        xmlns="http://www.w3.org/2000/svg"
                        viewBox="0 0 497.000000 512.000000"
                        preserveAspectRatio="xMidYMid meet"
                        class="w-4 h-4"
                    >

                        <g
                            transform="translate(0.000000,512.000000) scale(0.100000,-0.100000)"
                            stroke="none"
                        >
                            <path
                                d="M1404 5105 c-289 -63 -494 -314 -494 -607 l0 -78 -410 0 c-462 0 -455 1 -484 -70 -14 -36 -16 -106 -16 -591 0 -587 0 -590 50 -634 21 -19 38 -20 441 -23 l419 -3 0 -1152 c0 -1263 -2 -1214 60 -1339 80 -160 203 -268 374 -326 l81 -27 763 0 764 0 29 33 c28 31 29 35 29 140 0 108 0 108 -31 138 l-30 29 -752 5 c-752 5 -752 5 -793 27 -59 31 -121 106 -139 166 -13 44 -15 207 -15 1179 l0 1128 893 0 c688 0 897 3 916 13 13 6 34 25 45 40 21 28 21 38 24 598 2 514 1 573 -14 605 -32 68 21 64 -970 64 l-897 0 5 73 c6 86 31 148 83 199 45 44 87 65 157 78 33 6 430 9 1048 8 l995 -3 5 -445 c5 -437 5 -446 27 -487 30 -55 83 -106 141 -135 47 -23 50 -23 485 -26 l437 -3 0 -1235 0 -1236 29 -29 c29 -28 32 -29 136 -29 117 0 137 6 160 50 22 43 23 2576 0 2659 -35 131 -36 133 -574 672 -540 541 -538 539 -672 574 -77 21 -2211 21 -2305 0z m-384 -855 c66 -19 66 -19 45 -110 -10 -44 -22 -83 -26 -86 -5 -3 -34 3 -65 12 -75 21 -201 16 -264 -13 -60 -26 -108 -76 -139 -143 -35 -76 -36 -219 -2 -296 60 -138 218 -201 395 -160 51 12 71 13 77 5 3 -6 12 -45 19 -86 15 -88 17 -85 -79 -104 -84 -17 -240 -17 -311 0 -130 31 -255 124 -309 229 -49 97 -68 273 -40 387 45 189 186 326 382 371 69 15 257 12 317 -6z m665 9 c32 -6 75 -17 96 -25 l36 -15 -25 -87 c-13 -48 -25 -88 -26 -89 -1 -1 -30 7 -65 17 -116 36 -243 22 -271 -29 -33 -63 7 -112 132 -161 122 -49 155 -67 206 -113 61 -56 84 -111 84 -199 0 -208 -200 -334 -474 -299 -92 12 -198 45 -198 62 0 5 10 48 21 95 18 70 25 84 38 78 108 -44 214 -63 285 -50 19 4 49 18 66 32 25 21 30 33 30 69 0 38 -5 47 -36 73 -20 17 -74 44 -120 62 -105 40 -193 98 -228 151 -82 122 -46 283 82 373 80 56 235 80 367 55z m558 -276 c66 -233 89 -319 122 -458 6 -26 11 -14 34 80 15 61 63 230 106 378 l80 267 117 0 c65 0 118 -3 118 -7 0 -5 -73 -225 -162 -490 l-162 -483 -133 0 -132 0 -9 33 c-10 34 -292 914 -299 935 -4 9 24 12 120 12 l124 0 76 -267z"
                            />
                            <path
                                d="M3704 1936 c-17 -8 -34 -21 -38 -31 -3 -9 -6 -228 -6 -486 l0 -470-25 -24 c-24 -24 -28 -25 -183 -25 -158 0 -201 -9 -191 -38 2 -6 152 -200 333 -431 231 -296 336 -423 353 -427 14 -4 35 -2 48 4 25 12 665 824 673 855 3 10 -1 23 -9 28 -8 5 -86 9 -175 9 -155 0 -161 1 -182 23 -22 23 -22 25 -22 484 0 282 -4 472 -10 488 -18 48 -56 55 -307 55 -169 -1 -236 -4 -259 -14z"
                            />
                        </g>
                    </svg>
                    <span>
                        {{ $t('export') }}
                    </span>
                </div>
            </auto-button>
            <div
                v-if="autoRefreshSetup"
                class="bg-white text-black items-center px-4 py-1 uppercase"
            >
                <form-checkbox
                    v-model="autoRefresh"
                    name="auto_refresh"
                    :check-box-width="18"
                    :check-box-height="18"
                    hide-label
                    :options="[{text: autoRefreshMessage, value: 1}]"
                    class="shadow-lg px-4 py-2 border border-gray-400 rounded-lg"
                />
            </div>
        </div>
        <div class="intro-y w-full data-table relative h-auto">
            <div
                class="w-full custom-table z-10"
            >
                <div class="h-auto">
                    <div class="overflow-y-scroll">
                        <table class="styled-table mt-2">
                            <thead
                                ref="headerEle"
                                class="w-full text-left"
                            >
                            <tr>
                                <th
                                    v-for="(header, i) in headers"
                                    :key="`h-${i}`"
                                    :class="{
                                        sortable: typeof header.sortable === 'undefined' || header.sortable !== false,
                                        desc: (typeof header.sortable === 'undefined' || header.sortable === true) && sorting === header.name && order === 'desc',
                                        asc: (typeof header.sortable === 'undefined' || header.sortable === true) && sorting === header.name && order === 'asc'
                                    }"
                                    @click="onSorting(header)"
                                >
                                    {{ header.label }}
                                </th>
                            </tr>
                            <slot name="table-header" />
                            </thead>
                            <tbody
                                ref="bodyEle"
                                class="w-full overflow-y-scroll max-h-40 whitespace-nowrap text-left"
                            >
                                <slot :records="records" />
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
            <div
                class="text-center w-full"
            >
                <div class="flex justify-between space-x-2 items-center">
                    <div class="flex justify-start space-x-1 text-xs items-center">
                        <input v-model="page" type="text"  class="w-6 h-7 text-black text-center border border-gray-300 rounded-md shadow-sm" />
                        <span>/</span>
                        <span>{{ total_pages }}</span>
                        <span class="border-l pl-1 flex-auto">{{ fromAndToRecords.from }}-{{ fromAndToRecords.to }} {{ $i18n.t('of') }} {{ total_records }}</span>
                    </div>
                    <div class="transform translate-y-2">
                        <auto-button
                            type="secondary"
                            :block="false"
                            @click="loadData"
                        >
                            <div
                                class="flex justify-center space-x-2 items-center"
                            >
                                <svg
                                    xmlns="http://www.w3.org/2000/svg"
                                    x="0px"
                                    y="0px"
                                    viewBox="0 0 403.078 403.078"
                                    xml:space="preserve"
                                    class="w-4 h-4"
                                >
                                    <g>
                                        <g>
                                            <path
                                                d="M390.637,44.605H55.505L95.47,21.535c5.519-3.183,7.408-10.237,4.223-15.758c-3.184-5.521-10.239-7.419-15.761-4.226 L6.679,46.144c-3.569,2.062-5.77,5.871-5.77,9.995c0,4.118,2.2,7.927,5.77,9.989l77.253,44.604c1.816,1.054,3.8,1.549,5.758,1.549 c3.988,0,7.868-2.068,10.003-5.769c3.186-5.521,1.296-12.575-4.223-15.764L55.517,67.683H379.1v226.925 c0,6.371,5.166,11.537,11.537,11.537c6.373,0,11.539-5.166,11.539-11.537V56.143C402.176,49.771,397.01,44.605,390.637,44.605z"
                                            />
                                            <path
                                                d="M396.4,336.951l-77.252-44.604c-5.521-3.193-12.58-1.295-15.762,4.227c-3.186,5.516-1.297,12.574,4.223,15.758 l39.953,23.07H23.979V108.478c0-6.372-5.167-11.539-11.538-11.539c-6.373,0-11.539,5.167-11.539,11.539v238.464 c0,6.371,5.166,11.537,11.539,11.537h335.133l-39.965,23.064c-5.52,3.184-7.408,10.242-4.223,15.764 c2.135,3.701,6.016,5.771,10.002,5.771c1.959,0,3.941-0.496,5.76-1.551l77.252-44.594c3.568-2.057,5.77-5.863,5.77-9.986 C402.17,342.822,399.971,339.014,396.4,336.951z"
                                            />
                                        </g>
                                    </g>
                                </svg>
                                <span>
                                    {{ $t('refresh') }}
                                </span>
                            </div>
                        </auto-button>
                    </div>
                </div>
                <div class="flex justify-start space-x-2 pt-2">
                    <a v-if="canGoBack" href="javascript:" @click="goFirstPage">
                        <svg xmlns="http://www.w3.org/2000/svg" class="h-4 w-4 mt-1" fill="none" viewBox="0 0 24 24" stroke="currentColor">
                            <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M11 19l-7-7 7-7m8 14l-7-7 7-7" />
                        </svg>
                    </a>
                    <a v-if="canGoBack" href="javascript:" @click="goBackPage">
                        <svg xmlns="http://www.w3.org/2000/svg" class="h-4 w-4 mt-1" fill="none" viewBox="0 0 24 24" stroke="currentColor">
                            <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M15 19l-7-7 7-7" />
                        </svg>
                    </a>
                    <div class="flex space-x-1 z-0">
                        <div class="relative">
                            <select v-model="ipp" class="bg-white text-black appearance-none leading-tight w-full px-6 py-1">
                                <option
                                    v-for="i in ippLists"
                                    :key="`ipp-${i}`"
                                    :selected="parseInt(ipp) === i"
                                >
                                    {{ i }}
                                </option>
                            </select>
                            <div class="pointer-events-none absolute inset-y-0 right-0 flex items-center px-2 text-gray-700">
                                <svg class="fill-current h-4 w-4" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20"><path d="M9.293 12.95l.707.707L15.657 8l-1.414-1.414L10 10.828 5.757 6.586 4.343 8z"/></svg>
                            </div>
                        </div>
                        <span class="pl-4">{{ $i18n.t('records_per_page') }}</span>
                    </div>
                    <a v-if="canGoNext" href="javascript:" @click="goNextPage">
                        <svg xmlns="http://www.w3.org/2000/svg" class="h-4 w-4 mt-1" fill="none" viewBox="0 0 24 24" stroke="currentColor">
                            <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M9 5l7 7-7 7" />
                        </svg>
                    </a>
                    <a v-if="canGoNext" href="javascript:" @click="goLastPage">
                        <svg xmlns="http://www.w3.org/2000/svg" class="h-4 w-4 mt-1" fill="none" viewBox="0 0 24 24" stroke="currentColor">
                            <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M13 5l7 7-7 7M5 5l7 7-7 7" />
                        </svg>
                    </a>
                </div>
            </div>
        </div>
    </div>
</template>

<script setup>
import FormCheckbox from "~/components/form/form-checkbox.vue";
import Cookies from "js-cookie";
import {computed, inject, nextTick, onBeforeUnmount, onMounted, ref, useSlots, watch} from "vue";
import {useRoute} from "vue-router";
import axios from "axios";
import {useI18n} from "vue-i18n";
import {CONFIG} from "~/config.js";
import AutoButton from "~/components/button/auto-button.vue";
import {useAdminStore} from "~/stores/admin.js";

const slots = useSlots();

const props = defineProps({
    filters: {
        required: false,
        type: Array,
        default: () => [],
    },
    hiddenFilters: {
        required: false,
        type: Array,
        default: () => [],
    },
    headers: {
        required: false,
        type: Array,
        default: () => [],
    },
    model: {
        required: true,
        type: String,
    },
    url: {
        required: false,
        type: [String, Object],
        default: () => {
            return '/dt/';
        }
    },
    noExport: {
        required: false,
        type: Boolean,
        default: false
    },
});

const emit = defineEmits(['loaded']);

const loadCount = ref(0);
const loading = ref(false);
const page = ref(1);
const ipp = ref(null);
const total_records = ref(0);
const total_pages = ref(0);
const records = ref([]);
const sorting = ref(null);
const order = ref('desc');
const filter_form = ref({});
const filtered = ref(false);
const autoRefresh = ref(false);
const autoRefreshSetup = ref(false);
const autoRefreshSeconds = 60;
const autoRefreshCountdown = ref(autoRefreshSeconds);
const autoRefreshInterval = ref(null);
const headerEle = ref();
const bodyEle = ref();
const remember_key = `${CONFIG.ROLE}_ipp`;
const remember_auto_refresh = `${CONFIG.ROLE}_auto_refresh`;

const $helper = inject('$helper');
const $i18n = useI18n();
const $route = useRoute();
const $adminStore = useAdminStore();
const $admin = computed(() => {
    return $adminStore.account;
});

const ippLists = [100, 300, 500, 1000, 3000, 5000];

const getPostBody = () => {
    const body = {
        model: props.model,
        p: page.value,
        ipp: ipp.value,
        sorting_column: sorting.value,
        sorting: order.value,
    };

    if (props.filters) {
        Object.keys(filter_form.value).forEach(key => {
            if (filter_form.value[key] === 0 || filter_form.value[key] === '0' || (filter_form.value[key] && filter_form.value[key] !== '')) {
                body[key] = filter_form.value[key];
            }
        });
    }

    if (props.hiddenFilters) {
        props.hiddenFilters.forEach(row => {
            body[row.name] = row.value;
        });
    }

    return body;
};

const loadData = async () => {
    try {
        loading.value = true;
        const data = await axios.post(props.url, getPostBody());

        total_records.value = data.total_records;
        total_pages.value = data.total_pages;
        records.value = data.records;
        loadCount.value++;

        emit('loaded');
    } catch (e) {
        console.log(e);
    } finally {
        setTimeout(() => {
            loading.value = false;
        }, 300);
    }
};
const autoRefreshMessage = computed(() => {
    if (!autoRefreshSetup.value || !autoRefresh.value) {
        return $i18n.t('auto_refresh');
    } else {
        if (!autoRefresh.value) {
            return $i18n.t('auto_refresh');
        } else {
            return $i18n.t('auto_refresh') + ' (' + autoRefreshCountdown.value + 's)';
        }
    }
});
const canGoBack = computed(() => {
    return parseInt(page.value) > 1;
});
const canGoNext = computed(() => {
    return parseInt(page.value) < parseInt(total_pages.value);
});
const fromAndToRecords = computed(() => {
    let from = 1;
    if (page.value > 1) {
        from = ((page.value - 1) * ipp.value) + 1;
    }

    let to = (page.value * ipp.value);

    if (to >= total_records.value) {
        to = total_records.value;
    }

    return {
        from,
        to
    };
});
const goBackPage = async () => {
    if (canGoBack.value) {
        page.value--;
    }
};
const goNextPage = async () => {
    if (canGoNext.value) {
        page.value++;
    }
};
const goFirstPage = async () => {
    if (canGoBack.value) {
        page.value = 1;
    }
};
const goLastPage = async () => {
    if (canGoNext.value) {
        page.value = parseInt(total_pages.value);
    }
};

const onSorting = async (header) => {
    if (typeof header.sortable === 'undefined' || header.sortable !== false) {
        if (header.name === sorting.value) {
            if (order.value === 'desc') order.value = 'asc';
            else order.value = 'desc';
        } else {
            order.value = 'desc';
        }

        sorting.value = header.name;
        page.value = 1;//Back to page 1

        await loadData();
    }
};

const onFilterSubmit = async () => {
    if (!loading.value) {
        Object.keys(filter_form.value).forEach(key => {
            if (filter_form.value[key] && filter_form.value[key] !== '') {
                filtered.value = true;
            }
        });

        // if (filtered.value) {
            page.value = 1;

            await loadData();
        // }
    }
};

const onFilterReset = async () => {
    if (props.filters && filtered.value) {
        Object.keys(filter_form.value).forEach(key => {
            if (filter_form.value[key] && filter_form.value[key] !== '') {
                filter_form.value[key] = '';
            }
        });

        page.value = 1;
        filtered.value = false;

        await loadData();
    }
};

const permissions = computed(() => {
    if (!$admin.value) return [];
    if (!$admin.value.group) return [];
    if (!$admin.value.group.permissions) return [];
    return $admin.value.group.permissions.map(r => {
        return r.permission_tag;
    });
});

const hasAction = computed(() => {
    return !!(slots.action && slots.action().length);
});

const hasExport = computed(() => {
    if (props.noExport) return false;
    return $helper.hasPermission($admin.value, 'export');
});

const onExport = async () => {
    try {
        loading.value = true;

        let body = getPostBody();
        body.headers = props.headers;
        body.export = 1;
        body.export_file_name = Math.floor(Date.now() / 1000) + '.csv';

        const data = await axios.post(props.url, body);

        const temp = window.URL.createObjectURL(new Blob([data]));
        const link = document.createElement('a');
        link.href = temp;
        link.setAttribute('download', body.export_file_name);
        document.body.appendChild(link);
        link.click();
    } catch (e) {

    } finally {
        loading.value = false;
    }
};

const triggerAutoRefreshCheck = async () => {
    if (autoRefresh.value) {
        autoRefreshInterval.value = setTimeout(autoRefreshCheck, 1000);
    } else {
        autoRefreshCountdown.value = autoRefreshSeconds;
    }
};

const autoRefreshCheck = async () => {
    if (autoRefreshCountdown.value <= 0) {
        await loadData();
        autoRefreshCountdown.value = autoRefreshSeconds;
    } else {
        autoRefreshCountdown.value--;
    }

    autoRefreshInterval.value = setTimeout(autoRefreshCheck, 1000);
};

watch(page, async () => {
    await loadData();
});
watch(ipp, async () => {
    page.value = 1;

    Cookies.set(remember_key, ipp.value);

    await loadData();
});
watch(autoRefresh, async (newValue, oldValue) => {
    Cookies.set(remember_auto_refresh, newValue);

    //DISABLED TURN TO ENABLED
    if (!oldValue && newValue) {
        autoRefreshCountdown.value = autoRefreshSeconds;

        await triggerAutoRefreshCheck();
    } else if (!newValue && oldValue) {//ENABLED TURN TO DISABLED
        autoRefreshCountdown.value = autoRefreshSeconds;

        if (autoRefreshInterval.value) {
            clearInterval(autoRefreshInterval.value);
        }
    }
});

onMounted(async () => {
    //REMEMBER IPP
    if (Cookies.get(remember_key)) {
        ipp.value = Cookies.get(remember_key);
    } else {
        ipp.value = ippLists[0];
    }

    //REMEMBER AUTO REFRESH
    if (Cookies.get(remember_auto_refresh)) {
        autoRefresh.value = Cookies.get(remember_auto_refresh);
    }

    //FIND FIRST SORTABLE
    sorting.value = props.headers.find(r => {
        return typeof r.sortable === 'undefined' || r.sortable !== false;
    }).name || null;

    //BUILD THE FILTER FORM
    if (props.filters && Array.isArray(props.filters) && props.filters.length) {
        props.filters.forEach(row => {
            if (Array.isArray(row) && row.length) {
                row.forEach(row2 => {
                    filter_form.value[`${row2.name}`] = '';
                });
            } else {
                filter_form.value[`${row.name}`] = '';
            }
        });
    }

    await nextTick(() => {
        autoRefreshSetup.value = true;
    });
});

onBeforeUnmount(() => {
    if (autoRefreshInterval.value) {
        clearInterval(autoRefreshInterval.value);
    }
});

defineExpose({
    loadData,
});
</script>
